
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>iOS设计模式解析（三）适配器模式 / 憋错料</title>

    <meta name="description" content="iOS设计模式解析（三）适配器模式 适配器模式:将一个类的借口转换成客户端希望的另一个接口 有一个很直观的图: 例如      :电源适配器(将110V电压转换成220V电压,其中Traget是220V电压,adaptee就是110V电压,Adapter就是适配器): 代码实现: 1 #import &quot;Adapter.h&quot; 2 3 @implementation Adapter 4 -(int)changeTo220:(int)adaptee{ 5 return 220; 6 } 7 @end Adapter  ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">iOS设计模式解析（三）适配器模式</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<ul>
<li>适配器模式：将一个类的借口转换成客户端希望的另一个接口</li>
<li>有一个很直观的图：　　<img src="//9b902db8-3705-4106-90e8-6e9e5784a61b/image.tiff" /></li>
<li>例如&nbsp;&nbsp; &nbsp; &nbsp;：电源适配器（将110V电压转换成220V电压，其中Traget是220V电压，adaptee就是110V电压，Adapter就是适配器）：<img src="//77e8fd7d-fdcd-43b7-bfd9-967b681af9eb/image.tiff" />　　</li>
</ul>
<ul>
<li>代码实现：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvQ29udHJhY3RlZEJsb2NrLmdpZg==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg" /></p>

<pre>1 #import "Adapter.h"
2
3 @implementation Adapter
4 -(int)changeTo220:(int)adaptee{
5     return 220;
6 }
7 @end</pre>
<p>Adapter</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvQ29udHJhY3RlZEJsb2NrLmdpZg==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg" /></p>

<pre> 1 #import "ViewController.h"
 2 #import "Adapter.h"
 3 @interface ViewController ()
 4
 5 @end
 6
 7 @implementation ViewController
 8
 9 - (void)viewDidLoad {
10     [super viewDidLoad];
11
12     int current       = 110;
13     Adapter * adapter = [[Adapter alloc]init];
14     int new           = [adapter changeTo220:110];
15     NSLog(@"%d",new);
16
17 }
18
19 - (void)didReceiveMemoryWarning {
20     [super didReceiveMemoryWarning];
21 }
22
23 @end</pre>
<p>ViewController</li>
<li>打印结果：<br />
<br /><strong>2016-05-09 16:46:26.262 Factory[2766:204337] 220</strong></li>
<li>延伸总结：为什么说委托模式其实是适配器模式。其实Objecct-C中协议的概念就是定义一些外界可用的接口，那么外界需要用的值本类中的格式不一致。那么我们是不是可以在本类中声明一些接口，然后在本类接口中将外界需要的值我组织适配好通过声明的接口（协议）来传给外界。所以这么看来委托模式其实是适配器模式。</li>
</ul>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 22:05:15 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>iOS设计模式解析（三）适配器模式的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kn7zEM.html" rel="bookmark">IOS设计模式之三（适配器模式，观察者模式）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文原文请见:http://www.raywenderlich.com/46988/ios-design-patterns. 由 @krq_tiger(http://weibo.com/xmuzyq)翻译,如果你发现有什么错误,请与我联系谢谢. 适配器(Adapter)模式 适配器可以让一些接口不兼容的类一起工作.它包装一个对象然后暴漏一个标准的交互接口. 如果你熟悉适配器设计模式,苹果通过一个稍微不同的方式来实现它-苹果使用了协议的方式来实现.你可能已经熟悉UITableViewDelegat			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVqPqj4.html" rel="bookmark">IOS设计模式第三篇之外观设计模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				外观设计模式: 这个外观设计模式提供了一个单独的接口给复杂的子系统.而不是暴露用户的一组类和API,你仅仅暴露一个简单的同一的API. 下面的图片解释这个概念: API的用户根本不知道后面系统的复杂性.这种模式是理想的在处理大量的类,特别是当他们复杂的使用或者很难理解的时候. 这个外观设计模式使用系统的接口和你隐藏的实现来分离代码.他也减少了依赖外部代码的子系统运作.这也是有用的如果在外观设计模式的类可能会改变,外部类可以保留相同的API同时改变幕后的事情. 例如有一天你可能想替换你的服务器端,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEOWgQ3.html" rel="bookmark">Object-c 编程之道 IOS设计模式解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一,初识 设计模式是为特定场景下的问题而定制的解决方案.特定的场景指问题所在重复出现的场景.问题指特定环境下你想达成的目标.定制的解决方案是指在特定环境下克服问题限制条件而达成目标的一种设计. 设计模式是经过时间证明为有效的,对特定面向对象设计问题主要方面的一种抽象,体现了面向对象的重要思想.有些设计原则影响着设计模式,而这些原则是构建可复用,可维护的面向对象应用程序的经验法则,比如&quot;优先使用对象组合而不是类继承&quot; ,&quot;针对接口编程而不是针对实现编程&quot;&quot;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0l8bxX0.html" rel="bookmark">iOS设计模式解析（五）责任链模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				责任链模式:使多个对象都有机会处理请求,从而避免发送者和接受者之间发生耦合. 应用场景: 有多个对象可以处理请求,而处理程序只有在运行时才能确定 例如: 英雄联盟中伤害计算,伤害类型分为AP.AD.真实伤害(无视任何防御直接造伤害). 结构分析:整个结构就在这个攻击处理器的抽象.抽象一个属性,下一个处理器(newxHandler).抽象一个方法,处理攻击(handleAttack) 1 -(void)handleAttack:(attack *)attack{ 2 [nextHandler ha			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLJlbO3.html" rel="bookmark">IOS设计模式之一（MVC模式，单例模式）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文原文请见:http://www.raywenderlich.com/46988/ios-design-patterns. 由 @krq_tiger(http://weibo.com/xmuzyq)翻译,如果你发现有什么翻译错误,请与我联系谢谢. iOS 设计模式-你可能已经听说过这个词,但是你真正理解它意味着什么吗?虽然大多数的开发者可能都会认为设计模式是非常重要的,然而关于设计模式这一主题的文章却不多,并且有时候我们开发者在写代码的时候也不会太关注它. 在软件设计领域,设计模式是对通用问题			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0nvdKN0.html" rel="bookmark">研磨设计模式解析及python代码实现&mdash;&mdash;&lpar;三&rpar;适配器模式&lpar;Adapter&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.适配器模式定义 将一个类的接口转换成另外一个接口,适配器模式使得原本由于接口不兼容,而不能在一起工作的哪些类能够在一起工作. 二.python 实现 1 import string 2 import cPickle as p 3 import datetime 4 import os 5 class LogModel: 6 logId=&quot;&quot; 7 operateUser=&quot;&quot; 8 operateTime=&quot;&quot; 9 logContent=&quo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jZq9o0.html" rel="bookmark">通俗易懂设计模式解析&mdash;&mdash;适配器模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 前面完成了创建型的设计模式的分享,创建型的设计模式解决的是对象创建的问题.今天开始介绍结构型的设计模式,其中结构型设计模式包括:适配器模式.桥接模式.装饰模式.组合模式.外观模式.享元模式.代理模式.结构型设计模式解决的是类与对象的组合关系.今天讲结构型对象中的第一个——适配器模式.适配器模式——顾名思义嘛.在我们平常的理解中,适配器是干啥用的呢?不就是将两个原本不匹配的东西转换为匹配罢了.适配器是接口转换器,比如电源适配器,USB接口转换器等等. 适配器模式介绍 一.来由 在系统程序中,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzXZ283.html" rel="bookmark">iOS 设计模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Ios 设计模式,你可能听说过,但是你真正知道这是什么意思么?大部分的开发者大概都同意设计模式很重要,但是关于这一部分却没有很多的文章去介绍它,我们开发者很多时候写代码的时候也并不重视设计模式. 设计模式是在软件设计上去解决普通问题的可重用的方法.他们是是帮助你让所写的代码更加容易理解和提高可重用性的模板.它们还可以帮你创建松散耦合的代码是你能不费很大功夫就可以改变或者替代你的代码中的一部分. 如果你对设计模式感到生疏,那么我有个好消息告诉你!首先,你已经用了很多ios设计模式多亏了Cocoa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qD8NN0.html" rel="bookmark">Retrofit源码设计模式解析（上）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Retrofit通过注解的方法标记HTTP请求参数,支持常用HTTP方法,统一返回值解析,支持异步/同步的请求方式,将HTTP请求对象化,参数化.真正执行网络访问的是Okhttp,Okhttp支持HTTP&amp;HTTP2,因此,使用Retrofit可以支持REST.HTTPS及SPDY. 行业内分析Retrofit的使用方法的文章已经比较丰富,这里不再赘述,如想了解这部分内容,请参考如下链接. &lt;用 Retrofit 2 简化 HTTP 请求&gt; &lt;Retrofit 源码解析&gt;			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/E3wGzZ3.html" rel="bookmark" class="title">第九章  前七章总结考试答案</a>
					<div>
						前七章总结测验见附件内容					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/v0k7dd0.html" rel="bookmark" class="title">管理应用程序状态</a>
					<div>
						管理应用程序状态 原文:Managing Application State作者:Steve Smith翻译:姚阿勇(Dr.Yao)校对:高嵩 在 ASP.NET Core 中,有多种途径可以对应用程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmG8lQ3.html" rel="bookmark" class="title">iOS 数据库多线程操作</a>
					<div>
						SQLite是支持多线程操作的, 需要在初始化database是做一个线程安全的config,参考下面链接,看起来比较复杂. http://www.cnblogs.com/wfwenchao/p/39 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vEw1j0.html" rel="bookmark" class="title">AFNetworking使用总结</a>
					<div>
						AFNetworking使用总结 关于AFNetworking使用总结 以及一些错误的解决办法. AD:WOT2015 互联网运维与开发者大会 热销抢票 分享类型:游戏开发相关 1 将AFNetWor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lXVLp0.html" rel="bookmark" class="title">yum install nagios and pnp4nagios</a>
					<div>
						环境:centos6.2 1.下载并安装epel包 links    http://fedoraproject.org/wiki/EPEL 2.安装nagios及插件 yum install nagi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0awdOk4.html" rel="bookmark" class="title">安装mint的时候提示：Not compatible with your operating system or architecture&colon; &lbrack;email&amp;&num;160&semi;protected&rsqb;</a>
					<div>
						Since fsevents is an API in OS X allows applications to register for notifications of changes to a g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nEZ6vM.html" rel="bookmark" class="title">saiku源代码安装</a>
					<div>
						以前的文章介绍了如何直接安装saiku,http://www.cnblogs.com/liqiu/p/5183894.html .这里面偷懒没有源代码编译,不过这几天也就这么用了. 最近随着使用的深入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz5bd84.html" rel="bookmark" class="title">Win7里IIS7部署WebService</a>
					<div>
						最近忙于一个Web的Bug修正,是先人写的一个东东,架构很简单,一个前端的项目,一个WebService的项目,以及后台的一些dll.之前一直很排斥这个产品,因为它没法启动,印象中没有跑得起来过的时候 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MX7Oaw4.html" rel="bookmark" class="title">51nod 1674 区间的价值V2&lpar;思维&plus;拆位&plus;尺取法&rpar;</a>
					<div>
						最近被四区题暴虐... 题意:lyk拥有一个区间. 它规定一个区间的价值为这个区间中所有数and起来的值与这个区间所有数or起来的值的乘积. 例如3个数2,3,6.它们and起来的值为2,or起来的值 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kGzJE0.html" rel="bookmark" class="title">关于是用dotnet获取本机IP地址&plus;计算机名的方法</a>
					<div>
						印象中在maxscript帮助文档里找到过方法,但是当时没记下来.只能通过dotnet实现了. 如果电脑有无线网卡和本地连接,可能会出现乱码,也问了写dotnet的朋友,提供了一些思路,不过最终还是使 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3522y14.html" rel="bookmark" class="title">jquery练习事件的添加移除</a>
					<div>
						&lt;!doctype html&gt; &lt;html&gt; &lt;head&gt; &lt;meta charset=&quot;gb2312&quot;&gt; &lt;title&gt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPWno14.html" rel="bookmark" class="title">linux 全网备份项目</a>
					<div>
						linux全网备份项目 要求 1.基本备份要求 已知 3 台服务器主机名分别为 web01.backup .nfs01,主机信息见下表: 服务器说明 外网IP(NAT) 内网IP(NAT) 主机名称  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME66Gg0.html" rel="bookmark" class="title">邮箱制作</a>
					<div>
						&lt;body background=&quot;../HTML基础/0709/1234.jpg&quot;&gt;&lt;center&gt;&lt;form&gt;&lt;table width ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vBw5X3.html" rel="bookmark" class="title">已知二叉树的先序，中序遍历，求后续遍历</a>
					<div>
						//已知二叉树的先序,中序遍历,求后续遍历 struct TreeNode { char elem; struct TreeNode* left; struct TreeNode* right; }; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dEEXg3.html" rel="bookmark" class="title">人性2</a>
					<div>
						当我自己经历这些的时候,我慢慢知道人性是怎么一回事. 我不知道生活是什么样,我只知道去实践. 人性,相当于一个墙头草,在良知和放纵.邪恶之间摇摆.如果痛苦,为什么活着?为什么要为别人活着? 当承受痛苦 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Rjzr50.html" rel="bookmark" class="title">PostgreSQL Excel包含中文字符的数据导入方法</a>
					<div>
						1.excel文件处理 删除掉标题行,另存为 以逗号分隔符的CSV文件 2.文件格式处理Notepad ++ 1).文件转换为UNIX格式 2).格式转换为UTF8无BOM 3.上传到数据库导入 注意 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDnvG83.html" rel="bookmark" class="title">magento 控制器复习</a>
					<div>
						1.在config.xml里面添加如下信息 app/code/local/Magentotutorial/Helloworld/etc/config.xml 2.创建控制器 app/code/loca ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mmw7Xn3.html" rel="bookmark" class="title">创建数据库，创建表，增删改语句</a>
					<div>
						数据类型: --类似于C#中的数据类型 Datetime   范围是:1753.1.1-- 9999.12.31 Smalldatetime      1900.1.1 --2079.6.6 创建数据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzDZAq3.html" rel="bookmark" class="title">nodejs express框架一个工程中同时使用ejs模版和jade模版</a>
					<div>
						在某些项目中,比如你接手了一个别人的项目然后你不想用蛋疼的ejs,或者你不想用蛋疼的jade.你有不想重写之前的页面,那么你现在可能需要新引入ejs或者jade模块,你仅仅需要做下面两步也许就能完成使 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3q15Qp3.html" rel="bookmark" class="title">自问自答-hadoop在安全模式下究竟干了什么见不得人的事</a>
					<div>
						本来想自己从网上搜集整理的,但是发现吴超写的刚刚好,不多不少,所以直接转载(图片失效了,用自己的图片) http://www.superwu.cn/2013/08/23/548/ 在hadoop集群的 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
